Bug 23681 - Patron restrictions should be user definable
Summary: Patron restrictions should be user definable
Status: Signed Off
Alias: None
Product: Koha
Classification: Unclassified
Component: Patrons (show other bugs)
Version: master
Hardware: All All
: P5 - low enhancement (vote)
Assignee: Andrew Isherwood
QA Contact: Katrin Fischer
URL:
Keywords:
: 6775 (view as bug list)
Depends on:
Blocks:
 
Reported: 2019-09-26 13:59 UTC by Andrew Isherwood
Modified: 2022-06-29 15:19 UTC (History)
10 users (show)

See Also:
Change sponsored?: Sponsored
Patch complexity: Large patch
Documentation contact:
Documentation submission:
Text to go in the release notes:
Version(s) released in:


Attachments
Bug 23681: Add PatronRestrictionTypes syspref (3.33 KB, patch)
2019-10-07 09:42 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 23681: Add debarment_types (5.39 KB, patch)
2019-10-07 09:42 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 23681: Add modify_patron_restrictions perm (5.26 KB, patch)
2019-10-07 09:42 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 23681: Add Koha::RestrictionType(s) (3.32 KB, patch)
2019-10-07 09:42 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 23681: Add management UI (14.42 KB, patch)
2019-10-07 09:42 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 23681: Allow for changes to debarments (5.59 KB, patch)
2019-10-07 09:42 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 23681: Allow for selection of restriction type (5.88 KB, patch)
2019-10-07 09:42 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 23681: Clean up on delete (1.88 KB, patch)
2019-10-07 09:42 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 23681: Add unit tests (4.98 KB, patch)
2019-10-07 09:42 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 23681: Add PatronRestrictionTypes syspref (3.33 KB, patch)
2019-10-07 10:03 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 23681: Add debarment_types (5.39 KB, patch)
2019-10-07 10:03 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 23681: Add modify_patron_restrictions perm (5.26 KB, patch)
2019-10-07 10:03 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 23681: Add Koha::RestrictionType(s) (3.41 KB, patch)
2019-10-07 10:03 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 23681: Add management UI (14.44 KB, patch)
2019-10-07 10:03 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 23681: Allow for changes to debarments (5.59 KB, patch)
2019-10-07 10:03 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 23681: Allow for selection of restriction type (5.91 KB, patch)
2019-10-07 10:03 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 23681: Clean up on delete (2.50 KB, patch)
2019-10-07 10:03 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 23681: Add unit tests (4.98 KB, patch)
2019-10-07 10:03 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 23681: Add PatronRestrictionTypes syspref (3.44 KB, patch)
2019-10-30 11:52 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 23681: Add debarment_types (5.39 KB, patch)
2019-10-30 11:52 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 23681: Add modify_patron_restrictions perm (5.23 KB, patch)
2019-10-30 11:53 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 23681: Add Koha::RestrictionType(s) (3.41 KB, patch)
2019-10-30 11:53 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 23681: Add management UI (14.44 KB, patch)
2019-10-30 11:53 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 23681: Allow for changes to debarments (5.56 KB, patch)
2019-10-30 11:53 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 23681: Allow for selection of restriction type (5.91 KB, patch)
2019-10-30 11:53 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 23681: Clean up on delete (2.50 KB, patch)
2019-10-30 11:53 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 23681: Add unit tests (4.98 KB, patch)
2019-10-30 11:53 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 23681: Add PatronRestrictionTypes syspref (3.44 KB, patch)
2019-10-31 10:15 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 23681: Add debarment_types (5.39 KB, patch)
2019-10-31 10:15 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 23681: Add modify_patron_restrictions perm (5.23 KB, patch)
2019-10-31 10:15 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 23681: Add Koha::RestrictionType(s) (3.41 KB, patch)
2019-10-31 10:16 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 23681: Add management UI (14.44 KB, patch)
2019-10-31 10:16 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 23681: Allow for changes to debarments (5.56 KB, patch)
2019-10-31 10:16 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 23681: Allow for selection of restriction type (5.91 KB, patch)
2019-10-31 10:16 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 23681: Clean up on delete (2.50 KB, patch)
2019-10-31 10:16 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 23681: Add unit tests (4.98 KB, patch)
2019-10-31 10:16 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 23681: (follow-up) Fix typo (691 bytes, patch)
2019-11-07 11:47 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 23681: Add PatronRestrictionTypes syspref (3.53 KB, patch)
2019-11-11 12:45 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 23681: Add debarment_types (5.48 KB, patch)
2019-11-11 12:45 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 23681: Add modify_patron_restrictions perm (5.33 KB, patch)
2019-11-11 12:45 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 23681: Add Koha::RestrictionType(s) (3.51 KB, patch)
2019-11-11 12:45 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 23681: Add management UI (14.53 KB, patch)
2019-11-11 12:45 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 23681: Allow for changes to debarments (5.65 KB, patch)
2019-11-11 12:45 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 23681: Allow for selection of restriction type (6.00 KB, patch)
2019-11-11 12:45 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 23681: Clean up on delete (2.59 KB, patch)
2019-11-11 12:45 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 23681: Add unit tests (5.08 KB, patch)
2019-11-11 12:46 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 23681: (follow-up) Fix typo (785 bytes, patch)
2019-11-11 12:46 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 23681: Add PatronRestrictionTypes syspref (3.53 KB, patch)
2020-03-02 11:27 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 23681: Add debarment_types (5.48 KB, patch)
2020-03-02 11:27 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 23681: Add modify_patron_restrictions perm (5.31 KB, patch)
2020-03-02 11:27 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 23681: Add Koha::RestrictionType(s) (3.51 KB, patch)
2020-03-02 11:27 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 23681: Add management UI (14.53 KB, patch)
2020-03-02 11:27 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 23681: Allow for changes to debarments (5.93 KB, patch)
2020-03-02 11:27 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 23681: Allow for selection of restriction type (6.08 KB, patch)
2020-03-02 11:27 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 23681: Clean up on delete (2.59 KB, patch)
2020-03-02 11:27 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 23681: Add unit tests (5.08 KB, patch)
2020-03-02 11:28 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 23681: (follow-up) Fix typo (785 bytes, patch)
2020-03-02 11:28 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 23681: Add PatronRestrictionTypes syspref (3.47 KB, patch)
2022-02-09 14:37 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: Add debarment_types (5.66 KB, patch)
2022-02-09 14:38 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: Add modify_patron_restrictions perm (5.31 KB, patch)
2022-02-09 14:38 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: Add Koha::RestrictionType(s) (3.49 KB, patch)
2022-02-09 14:38 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: Add management UI (14.51 KB, patch)
2022-02-09 14:38 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: Allow for changes to debarments (5.98 KB, patch)
2022-02-09 14:38 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: Allow for selection of restriction type (5.90 KB, patch)
2022-02-09 14:38 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: Clean up on delete (2.59 KB, patch)
2022-02-09 14:38 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: Add unit tests (5.06 KB, patch)
2022-02-09 14:38 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: (follow-up) Fix typo (785 bytes, patch)
2022-02-09 14:38 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: (follow-up) Fix rebase issues (713 bytes, patch)
2022-02-09 14:38 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: (QA follow-up) Allow for translations (1.59 KB, patch)
2022-02-09 14:38 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: Add PatronRestrictionTypes syspref (3.47 KB, patch)
2022-03-28 10:32 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: Add debarment_types (5.66 KB, patch)
2022-03-28 10:32 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: Add modify_patron_restrictions perm (5.31 KB, patch)
2022-03-28 10:32 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: Add Koha::RestrictionType(s) (3.49 KB, patch)
2022-03-28 10:33 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: Add management UI (14.51 KB, patch)
2022-03-28 10:33 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: Allow for changes to debarments (5.98 KB, patch)
2022-03-28 10:33 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: Allow for selection of restriction type (5.90 KB, patch)
2022-03-28 10:33 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: Clean up on delete (2.59 KB, patch)
2022-03-28 10:33 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: Add unit tests (5.06 KB, patch)
2022-03-28 10:33 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: (follow-up) Fix typo (785 bytes, patch)
2022-03-28 10:33 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: (follow-up) Fix rebase issues (713 bytes, patch)
2022-03-28 10:33 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: (QA follow-up) Allow for translations (1.59 KB, patch)
2022-03-28 10:33 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: Updates for bug 26703 (3.60 KB, patch)
2022-03-28 10:33 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: (QA follow-up) Fix license, perlcritic & executable (4.81 KB, patch)
2022-03-28 10:33 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: CSS Build (132.74 KB, patch)
2022-03-28 10:33 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: (QA follow-up) Rename columns (6.80 KB, patch)
2022-03-28 11:42 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: (QA follow-up) Rename columns (6.80 KB, patch)
2022-03-28 11:48 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: (QA follow-up) Fix prefs (3.08 KB, patch)
2022-03-28 11:48 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: Add PatronRestrictionTypes syspref (3.48 KB, patch)
2022-05-03 11:24 UTC, Emmi Takkinen
Details | Diff | Splinter Review
Bug 23681: Add debarment_types (3.48 KB, patch)
2022-05-03 11:25 UTC, Emmi Takkinen
Details | Diff | Splinter Review
Bug 23681: Add modify_patron_restrictions perm (5.31 KB, patch)
2022-05-03 11:25 UTC, Emmi Takkinen
Details | Diff | Splinter Review
Bug 23681: Add Koha::RestrictionType(s) (3.50 KB, patch)
2022-05-03 11:26 UTC, Emmi Takkinen
Details | Diff | Splinter Review
Bug 23681: Add management UI (14.51 KB, patch)
2022-05-03 11:26 UTC, Emmi Takkinen
Details | Diff | Splinter Review
Bug 23681: Allow for changes to debarments (6.06 KB, patch)
2022-05-03 11:27 UTC, Emmi Takkinen
Details | Diff | Splinter Review
Bug 23681: Allow for selection of restriction type (5.91 KB, patch)
2022-05-03 11:27 UTC, Emmi Takkinen
Details | Diff | Splinter Review
Bug 23681: Clean up on delete (2.60 KB, patch)
2022-05-03 11:28 UTC, Emmi Takkinen
Details | Diff | Splinter Review
Bug 23681: Add unit tests (5.07 KB, patch)
2022-05-03 11:28 UTC, Emmi Takkinen
Details | Diff | Splinter Review
Bug 23681: (follow-up) Fix typo (793 bytes, patch)
2022-05-03 11:29 UTC, Emmi Takkinen
Details | Diff | Splinter Review
Bug 23681: (follow-up) Fix rebase issues (721 bytes, patch)
2022-05-03 11:29 UTC, Emmi Takkinen
Details | Diff | Splinter Review
Bug 23681: (QA follow-up) Allow for translations (1.62 KB, patch)
2022-05-03 11:30 UTC, Emmi Takkinen
Details | Diff | Splinter Review
Bug 23681: Updates for bug 26703 (3.61 KB, patch)
2022-05-03 11:30 UTC, Emmi Takkinen
Details | Diff | Splinter Review
Bug 23681: (QA follow-up) Fix license, perlcritic & executable (4.81 KB, patch)
2022-05-03 11:31 UTC, Emmi Takkinen
Details | Diff | Splinter Review
Bug 23681: (QA follow-up) Rename columns (6.81 KB, patch)
2022-05-03 11:31 UTC, Emmi Takkinen
Details | Diff | Splinter Review
Bug 23681: (QA follow-up) Fix prefs (3.09 KB, patch)
2022-05-03 11:32 UTC, Emmi Takkinen
Details | Diff | Splinter Review
Bug 23681: Fix QA issues (25.98 KB, patch)
2022-05-03 11:32 UTC, Emmi Takkinen
Details | Diff | Splinter Review
Bug 23681: DO NOT PUSH! Schema changes (2.79 KB, patch)
2022-05-03 11:32 UTC, Emmi Takkinen
Details | Diff | Splinter Review
Bug 23681: Add PatronRestrictionTypes syspref (3.47 KB, patch)
2022-05-04 11:41 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: Add debarment_types (5.66 KB, patch)
2022-05-04 11:41 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: Add modify_patron_restrictions perm (5.31 KB, patch)
2022-05-04 11:42 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: Add Koha::RestrictionType(s) (3.49 KB, patch)
2022-05-04 11:42 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: Add management UI (14.51 KB, patch)
2022-05-04 11:42 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: Allow for changes to debarments (6.05 KB, patch)
2022-05-04 11:42 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: Allow for selection of restriction type (5.90 KB, patch)
2022-05-04 11:42 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: Clean up on delete (2.59 KB, patch)
2022-05-04 11:42 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: Add unit tests (5.06 KB, patch)
2022-05-04 11:42 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: (follow-up) Fix typo (785 bytes, patch)
2022-05-04 11:42 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: (follow-up) Fix rebase issues (713 bytes, patch)
2022-05-04 11:42 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: (QA follow-up) Allow for translations (1.61 KB, patch)
2022-05-04 11:43 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: Updates for bug 26703 (3.60 KB, patch)
2022-05-04 11:43 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: (QA follow-up) Fix license, perlcritic & executable (4.81 KB, patch)
2022-05-04 11:43 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: (QA follow-up) Rename columns (6.80 KB, patch)
2022-05-04 11:43 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: (QA follow-up) Fix prefs (3.08 KB, patch)
2022-05-04 11:43 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: Fix QA issues (25.98 KB, patch)
2022-05-04 11:43 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: DO NOT PUSH! Schema changes (2.79 KB, patch)
2022-05-04 11:43 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: (QA follow-up) Move preference again (5.11 KB, patch)
2022-05-04 11:43 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: (QA follow-up) Restore customisablity of description (7.72 KB, patch)
2022-05-04 11:43 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: (QA follow-up) Merge update files (7.03 KB, patch)
2022-05-04 11:44 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: (QA follow-up) Proper handling of default option (10.99 KB, patch)
2022-05-04 11:44 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: DBIC Rebuild (3.46 KB, patch)
2022-05-04 11:44 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: Add PatronRestrictionTypes syspref (3.47 KB, patch)
2022-05-06 08:40 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: Add debarment_types (5.66 KB, patch)
2022-05-06 08:40 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: Add modify_patron_restrictions perm (5.31 KB, patch)
2022-05-06 08:40 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: Add Koha::RestrictionType(s) (3.49 KB, patch)
2022-05-06 08:40 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: Add management UI (14.51 KB, patch)
2022-05-06 08:40 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: Allow for changes to debarments (6.05 KB, patch)
2022-05-06 08:40 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: Allow for selection of restriction type (5.90 KB, patch)
2022-05-06 08:40 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: Clean up on delete (2.59 KB, patch)
2022-05-06 08:41 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: Add unit tests (5.06 KB, patch)
2022-05-06 08:41 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: (follow-up) Fix typo (785 bytes, patch)
2022-05-06 08:41 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: (follow-up) Fix rebase issues (713 bytes, patch)
2022-05-06 08:41 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: (QA follow-up) Allow for translations (1.61 KB, patch)
2022-05-06 08:41 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: Updates for bug 26703 (3.60 KB, patch)
2022-05-06 08:41 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: (QA follow-up) Fix license, perlcritic & executable (4.81 KB, patch)
2022-05-06 08:41 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: (QA follow-up) Rename columns (6.80 KB, patch)
2022-05-06 08:41 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: (QA follow-up) Fix prefs (3.08 KB, patch)
2022-05-06 08:41 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: Fix QA issues (25.98 KB, patch)
2022-05-06 08:42 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: DO NOT PUSH! Schema changes (2.79 KB, patch)
2022-05-06 08:42 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: (QA follow-up) Move preference again (5.11 KB, patch)
2022-05-06 08:42 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: (QA follow-up) Restore customisablity of description (7.72 KB, patch)
2022-05-06 08:42 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: (QA follow-up) Merge update files (7.03 KB, patch)
2022-05-06 08:42 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: (QA follow-up) Proper handling of default option (20.22 KB, patch)
2022-05-06 08:42 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: DBIC Rebuild (3.46 KB, patch)
2022-05-06 08:42 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: (follow-up) Mark fields at booleans (960 bytes, patch)
2022-05-06 08:42 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: Add PatronRestrictionTypes syspref (3.47 KB, patch)
2022-06-29 15:10 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: Add debarment_types (5.66 KB, patch)
2022-06-29 15:10 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: Add modify_patron_restrictions perm (5.31 KB, patch)
2022-06-29 15:10 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: Add Koha::RestrictionType(s) (3.49 KB, patch)
2022-06-29 15:10 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: Add management UI (14.51 KB, patch)
2022-06-29 15:11 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: Allow for changes to debarments (6.05 KB, patch)
2022-06-29 15:11 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: Allow for selection of restriction type (5.90 KB, patch)
2022-06-29 15:11 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: Clean up on delete (2.59 KB, patch)
2022-06-29 15:11 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: Add unit tests (5.06 KB, patch)
2022-06-29 15:11 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: (follow-up) Fix typo (785 bytes, patch)
2022-06-29 15:11 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: (follow-up) Fix rebase issues (713 bytes, patch)
2022-06-29 15:11 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: (QA follow-up) Allow for translations (1.61 KB, patch)
2022-06-29 15:11 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: Updates for bug 26703 (3.60 KB, patch)
2022-06-29 15:11 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: (QA follow-up) Fix license, perlcritic & executable (4.81 KB, patch)
2022-06-29 15:12 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: (QA follow-up) Rename columns (6.80 KB, patch)
2022-06-29 15:12 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: (QA follow-up) Fix prefs (3.08 KB, patch)
2022-06-29 15:12 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: Fix QA issues (25.98 KB, patch)
2022-06-29 15:12 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: DO NOT PUSH! Schema changes (2.79 KB, patch)
2022-06-29 15:12 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: (QA follow-up) Move preference again (5.17 KB, patch)
2022-06-29 15:12 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: (QA follow-up) Restore customisablity of description (7.72 KB, patch)
2022-06-29 15:12 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: (QA follow-up) Merge update files (7.03 KB, patch)
2022-06-29 15:12 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: (QA follow-up) Proper handling of default option (20.22 KB, patch)
2022-06-29 15:12 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: DBIC Rebuild (3.46 KB, patch)
2022-06-29 15:13 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 23681: (follow-up) Mark fields at booleans (960 bytes, patch)
2022-06-29 15:13 UTC, Martin Renvoize
Details | Diff | Splinter Review

Note You need to log in before you can comment on or make changes to this bug.
Description Andrew Isherwood 2019-09-26 13:59:33 UTC
Currently the patron restrictions are hard coded as enums in borrower_debarments.type, the available values are 'SUSPENSION','OVERDUES','MANUAL','DISCHARGE'.

We (PTFS Europe) have a customer requirement to:

- Provide a select box when adding a patron restriction containing user defined values for restriction types, the user defined values should be defined as authorised values
- Ensure a default value if no restriction type is selected
- Allow the name of the default value to be modifiable
- Ensure that if a restriction type authorised value is removed, any restrictions that use it should revert to the default value
- Make the selection of restriction type optional via a syspref

Currently, at the DB level, the default value is 'MANUAL'.

The plan is to:

DB MIGRATION
------------
- Add authorised_value_categories row for 'PATRON_RESTRICTIONS'
- Add authorised_values.core, default value 0
  - Implies AV cannot be deleted and authorised_values.authorised_value cannot be changed
- Add new borrower_debarments.debarment_type column
- Select distinct values from borrower_debarments.type
- For each $value:
  - Create AV rows:
    - authorised_values.authorised_value = $value
    - authorised_values.lib = $value
    - authorised_values.core = 1
  - ** Note id of each new row, associated with $value
  - update borrower_debarments.debarment_type to be appropriate AV id
  - Remove borrower_debarments.type

OTHER STUFF
-----------

- AV UI (and anything else that can bring about AV modification), should respect "core"
- Modify Patron::Debarments appropriate functions to abstract underlying changes i.e. we maintain backward compatibility with the way they currently work, we just obfuscate the fact that the "type" comes from a different table
- Overload AuthorisedValue::delete to allow us to call optional functions after delete - in a sane world this would be a trigger. This will allow us to set appropriate patron_debarments.debarment_type rows to default value upon AV deletion
Comment 1 Andrew Isherwood 2019-10-01 09:49:44 UTC
It has become increasingly apparent that using authorised values for this is not the most appropriate way forward. The number of modifications and additions to AV was increasing the scope of the work too much, it was clear that AV was not the correct place for this.

Therefore, I am intending creating a table specifically for Patron Restrictions and building the management UI for it, which will be placed probably under "Koha administration" > "Patrons and circulation"
Comment 2 Andrew Isherwood 2019-10-07 09:42:00 UTC Comment hidden (obsolete)
Comment 3 Andrew Isherwood 2019-10-07 09:42:03 UTC Comment hidden (obsolete)
Comment 4 Andrew Isherwood 2019-10-07 09:42:06 UTC Comment hidden (obsolete)
Comment 5 Andrew Isherwood 2019-10-07 09:42:08 UTC Comment hidden (obsolete)
Comment 6 Andrew Isherwood 2019-10-07 09:42:11 UTC Comment hidden (obsolete)
Comment 7 Andrew Isherwood 2019-10-07 09:42:14 UTC Comment hidden (obsolete)
Comment 8 Andrew Isherwood 2019-10-07 09:42:17 UTC Comment hidden (obsolete)
Comment 9 Andrew Isherwood 2019-10-07 09:42:20 UTC Comment hidden (obsolete)
Comment 10 Andrew Isherwood 2019-10-07 09:42:23 UTC Comment hidden (obsolete)
Comment 11 Andrew Isherwood 2019-10-07 09:42:44 UTC
Test plan:

- Apply bug
- Rebuild CSS
=> TEST: Observe a new syspref exists "PatronRestrictionTypes"
- Enable syspref "PatronRestrictionTypes"
- Navigate to your currently logged in patron's "details" page
- Choose More > Set permissions
=> TEST: Observe there is a new permission under "Manage Koha system settings" called "Manage patron restrictions (manage_patron_restrictions)"
- Ensure you are logged in as either a superlibrarian, or assign yourself "manage_patron_restrictions"
- Navigate to "Koha administration"
=> TEST: Observe a new menu option under "Patrons and circulation" called "Patron restrictions"
- Navigate to "Patron restrictions"
=> TEST: Observe that 4 restrictions exist "DISCHARGE", "MANUAL", "OVERDUES", "SUSPENSION"
- Click "New restriction"
- Enter a code and label for the new restriction
=> TEST: Observe that the code can only be entered in uppercase
- Click "Save"
=> TEST: Observe that the new restriction is listed in the table
- On the row containing the new restriction, click "Edit"
=> TEST: Observe that the label can be edited, but the code cannot
- Return to the table
=> TEST: Observe that none of the pre-existing restrictions can be deleted
- Navigate to the details for an existing patron
- Click on the "Restrictions" tab at the bottom
- Click "Add manual restriction"
=> TEST: In the "Type" select box, observe that all 5 restriction types are available for selection
- Select a restriction type
- Enter a comment
- Optionally, choose an expiration date
- Click "Add restriction"
- Return to the "Restrictions" tab
=> TEST: Observe that the newly added restriction is displayed
- Navigate to the patron's "You summary" page in the OPAC
=> Observe that the newly added restriction's "comment" is displayed
Comment 12 Andrew Isherwood 2019-10-07 10:03:19 UTC Comment hidden (obsolete)
Comment 13 Andrew Isherwood 2019-10-07 10:03:22 UTC Comment hidden (obsolete)
Comment 14 Andrew Isherwood 2019-10-07 10:03:25 UTC Comment hidden (obsolete)
Comment 15 Andrew Isherwood 2019-10-07 10:03:28 UTC Comment hidden (obsolete)
Comment 16 Andrew Isherwood 2019-10-07 10:03:31 UTC Comment hidden (obsolete)
Comment 17 Andrew Isherwood 2019-10-07 10:03:34 UTC Comment hidden (obsolete)
Comment 18 Andrew Isherwood 2019-10-07 10:03:37 UTC Comment hidden (obsolete)
Comment 19 Andrew Isherwood 2019-10-07 10:03:40 UTC Comment hidden (obsolete)
Comment 20 Andrew Isherwood 2019-10-07 10:03:43 UTC Comment hidden (obsolete)
Comment 21 Kyle M Hall 2019-10-09 13:04:16 UTC
A couple things:
* Can Koha::RestrictionType(s) be moved to Koha::Patron::RestrictionType(s)
* Can the table debarment_types be renamed to patron_restriction_types so our internal and external terminology match?

Thanks!
Comment 22 Andrew Isherwood 2019-10-09 13:20:13 UTC
Hi Kyle

Thanks for taking a look at this.

>Can Koha::RestrictionType(s) be moved to Koha::Patron::RestrictionType(s)

That's actually how I had it originally. However I moved it since, as far as I could see, everything in Koha::Patron::* was related to a singular patron and represented properties of that patron, which was not the case of RestrictionTypes, which represents the canonical list of restriction types, or a restriction type, not at all related to a patron. I'm happy to move it back if you feel it would be better there, but wanted to explain the rationale.

>Can the table debarment_types be renamed to patron_restriction_types so our internal and external terminology match?

Again, there is a rationale behind this. I named the table "debarment_types" because it was related to a pre-existing table "borrower_debarments" and I felt it would be confusing to name it "restriction_types". I realise that there is a move towards "restriction" rather than "debarment", and I have used the new term in the parts of this bug that are truly new, but where I'm interacting with stuff that's referring to debarments, it felt less confusing to use the same terminology for my bits. Hopefully, at some point, a full sweep of "debarment" => "restriction" will be done, so I felt this was a reasonable interim balance. Again, if you'd rather it be changed, I can do so.

Many thanks!
Comment 23 Martin Renvoize 2019-10-10 07:46:15 UTC
Now that my brain has caught up with Andrews explanation I'm happy here.

Yes, the Object <-> DB naming is inconsistent.. BUT by doing so the DB <-> DB and the Object <-> Object levels are both consistent at their level.  That makes reasonable sense to me, though in reality I'd love to have seen 'debartment' changed to 'restriction' at the DB level consistently at the time we decided to switch terms.. we're now dealing with legacy baggage.

As for RestrictionTypes I'm less sure.. but had a chat with Katrin and she agreed it did make sense as a top level object..   Patron::Restrictions makes sense as they're directly related but Patrons::RestrictionTypes doesn't as it's the restriction itself that has a type and is a level distinct..  Koha::Patron::Restriction::RestrictionTypes seems a little too nested.. so happy to stick to top level object here.
Comment 24 Andrew Isherwood 2019-10-30 11:52:54 UTC Comment hidden (obsolete)
Comment 25 Andrew Isherwood 2019-10-30 11:52:58 UTC Comment hidden (obsolete)
Comment 26 Andrew Isherwood 2019-10-30 11:53:01 UTC Comment hidden (obsolete)
Comment 27 Andrew Isherwood 2019-10-30 11:53:04 UTC Comment hidden (obsolete)
Comment 28 Andrew Isherwood 2019-10-30 11:53:07 UTC Comment hidden (obsolete)
Comment 29 Andrew Isherwood 2019-10-30 11:53:10 UTC Comment hidden (obsolete)
Comment 30 Andrew Isherwood 2019-10-30 11:53:14 UTC Comment hidden (obsolete)
Comment 31 Andrew Isherwood 2019-10-30 11:53:19 UTC Comment hidden (obsolete)
Comment 32 Andrew Isherwood 2019-10-30 11:53:22 UTC Comment hidden (obsolete)
Comment 33 Andrew Isherwood 2019-10-31 10:15:46 UTC Comment hidden (obsolete)
Comment 34 Andrew Isherwood 2019-10-31 10:15:50 UTC Comment hidden (obsolete)
Comment 35 Andrew Isherwood 2019-10-31 10:15:55 UTC Comment hidden (obsolete)
Comment 36 Andrew Isherwood 2019-10-31 10:16:00 UTC Comment hidden (obsolete)
Comment 37 Andrew Isherwood 2019-10-31 10:16:05 UTC Comment hidden (obsolete)
Comment 38 Andrew Isherwood 2019-10-31 10:16:09 UTC Comment hidden (obsolete)
Comment 39 Andrew Isherwood 2019-10-31 10:16:13 UTC Comment hidden (obsolete)
Comment 40 Andrew Isherwood 2019-10-31 10:16:18 UTC Comment hidden (obsolete)
Comment 41 Andrew Isherwood 2019-10-31 10:16:23 UTC Comment hidden (obsolete)
Comment 42 Andrew Isherwood 2019-11-07 11:47:29 UTC Comment hidden (obsolete)
Comment 43 Magnus Enger 2019-11-07 13:34:32 UTC
*** Bug 6775 has been marked as a duplicate of this bug. ***
Comment 44 Andrew Isherwood 2019-11-11 12:45:15 UTC Comment hidden (obsolete)
Comment 45 Andrew Isherwood 2019-11-11 12:45:20 UTC Comment hidden (obsolete)
Comment 46 Andrew Isherwood 2019-11-11 12:45:25 UTC Comment hidden (obsolete)
Comment 47 Andrew Isherwood 2019-11-11 12:45:31 UTC Comment hidden (obsolete)
Comment 48 Andrew Isherwood 2019-11-11 12:45:37 UTC Comment hidden (obsolete)
Comment 49 Andrew Isherwood 2019-11-11 12:45:43 UTC Comment hidden (obsolete)
Comment 50 Andrew Isherwood 2019-11-11 12:45:48 UTC Comment hidden (obsolete)
Comment 51 Andrew Isherwood 2019-11-11 12:45:54 UTC Comment hidden (obsolete)
Comment 52 Andrew Isherwood 2019-11-11 12:46:00 UTC Comment hidden (obsolete)
Comment 53 Andrew Isherwood 2019-11-11 12:46:05 UTC Comment hidden (obsolete)
Comment 54 Jonathan Druart 2020-01-23 10:21:59 UTC
(In reply to Andrew Isherwood from comment #1)
> It has become increasingly apparent that using authorised values for this is
> not the most appropriate way forward. The number of modifications and
> additions to AV was increasing the scope of the work too much, it was clear
> that AV was not the correct place for this.

Why? Can you explain?
That was my first reaction reading the patches.
Using AV will make the feature translatable in the future (bug 20307).
Comment 55 Jonathan Druart 2020-01-23 10:28:19 UTC
So you are adding a regression, the restrictions are no longer translatable.
Comment 56 Jonathan Druart 2020-01-23 10:30:45 UTC
Is the "default" flag really useful? We could imagine a new "internal" flag (to replace ronly) for AVs.
Comment 57 Andrew Isherwood 2020-01-27 09:26:55 UTC
(In reply to Jonathan Druart from comment #54)
> (In reply to Andrew Isherwood from comment #1)
> > It has become increasingly apparent that using authorised values for this is
> > not the most appropriate way forward. The number of modifications and
> > additions to AV was increasing the scope of the work too much, it was clear
> > that AV was not the correct place for this.
> 
> Why? Can you explain?
> That was my first reaction reading the patches.
> Using AV will make the feature translatable in the future (bug 20307).

Clearly AV would have been the preferable route, which is why I spent some considerable time trying to implement using AV before reluctantly abandoning it, it certainly wasn't abandoned lightly. There were too many requirements of this work that were not provided by AV and working around them was becoming increasingly cludgy and unmaintainable.

This work was done a few months ago, so my memory of it isn't what it was, but examples would be:
- the ability to specify a default restriction type, which any restrictions would fall back to if the restriction type they were using was deleted
- the ability to prevent certain restriction types from being edited
- the ability to prevent certain restriction types from being deleted

> So you are adding a regression, the restrictions are no longer translatable.

They were previously held in borrower_debarments.type, they are now in debarment_types, so I'm guessing adding translation support for the default values is not an insurmountable problem, I am happy to add whatever work is required to make that happen to this bug. Any additional values are added by the user anyway, so are by their nature translatable.

>Is the "default" flag really useful? We could imagine a new "internal" flag (to replace ronly) for AVs.

I believe so. Restrictions need a type, even if one is not explicitly chosen. Also, we need an ability to say "if a restriction type is deleted, any restrictions that use this type should fall back to type X", the default flag indicates which type is X.
Comment 58 Jonathan Druart 2020-01-27 10:28:49 UTC
(In reply to Andrew Isherwood from comment #57)
> (In reply to Jonathan Druart from comment #54)
> >Is the "default" flag really useful? We could imagine a new "internal" flag (to replace ronly) for AVs.
> 
> I believe so. Restrictions need a type, even if one is not explicitly
> chosen. Also, we need an ability to say "if a restriction type is deleted,
> any restrictions that use this type should fall back to type X", the default
> flag indicates which type is X.

I do not remember I saw a way to modify it, it's hardcoded in DB (and so could be in the code).
Comment 59 Andrew Isherwood 2020-01-27 12:29:14 UTC
The default (In reply to Jonathan Druart from comment #58)
> > t
> > I believe so. Restrictions need a type, even if one is not explicitly
> > chosen. Also, we need an ability to say "if a restriction type is deleted,
> > any restrictions that use this type should fall back to type X", the default
> > flag indicates which type is X.
> 
> I do not remember I saw a way to modify it, it's hardcoded in DB (and so
> could be in the code).

You're absolutely right, the default must always be "MANUAL" due to the way the restrictions were originally implemented, however the name can be changed so as far as the user is concerned, it can be anything they wish.
Comment 60 Andrew Isherwood 2020-03-02 11:27:34 UTC Comment hidden (obsolete)
Comment 61 Andrew Isherwood 2020-03-02 11:27:37 UTC Comment hidden (obsolete)
Comment 62 Andrew Isherwood 2020-03-02 11:27:40 UTC Comment hidden (obsolete)
Comment 63 Andrew Isherwood 2020-03-02 11:27:44 UTC Comment hidden (obsolete)
Comment 64 Andrew Isherwood 2020-03-02 11:27:47 UTC Comment hidden (obsolete)
Comment 65 Andrew Isherwood 2020-03-02 11:27:51 UTC Comment hidden (obsolete)
Comment 66 Andrew Isherwood 2020-03-02 11:27:54 UTC Comment hidden (obsolete)
Comment 67 Andrew Isherwood 2020-03-02 11:27:58 UTC Comment hidden (obsolete)
Comment 68 Andrew Isherwood 2020-03-02 11:28:01 UTC Comment hidden (obsolete)
Comment 69 Andrew Isherwood 2020-03-02 11:28:05 UTC Comment hidden (obsolete)
Comment 70 Jonathan Druart 2020-04-01 10:58:16 UTC
(In reply to Andrew Isherwood from comment #57)
> (In reply to Jonathan Druart from comment #54)
> > So you are adding a regression, the restrictions are no longer translatable.
> 
> They were previously held in borrower_debarments.type, they are now in
> debarment_types, so I'm guessing adding translation support for the default
> values is not an insurmountable problem, I am happy to add whatever work is
> required to make that happen to this bug. Any additional values are added by
> the user anyway, so are by their nature translatable.

This is a blocker. Please provide a fix.
Comment 71 Jonathan Druart 2020-04-01 13:27:15 UTC
To resume,
We have 4 defaults 'SUSPENSION','OVERDUES','MANUAL','DISCHARGE'. Prior to this patch, they were translatable from the template (see SWITCH in borrower_debarments.inc).
Now you can edit their description in the new admin view, but they cannot be correctly translated (depending on the language of the interface).

I made one suggestion to Andrew: remove the ability to edit the lib for those 4 defaults. So we could still use the SWITCH and default to the description for the others.
But it seems that it won't fit the need of the sponsor.

I do not have another solution however.
Comment 72 Martin Renvoize 2020-04-16 07:05:33 UTC
We need Ben to varify that they really want to change the description of any of the following types:

'Manual', 'Overdues', 'Suspension', 'Discharge'

And, to be honest, those should be easily altered via JS if required.. I don't think this should block the rest of the work.

So.. to me it feels like we just need to take the same approach as we now have with the accounts system, where the original system types are all coded in the template and thus translations are not lost and then we fallback to descriptions from the database for any new types.
Comment 73 Martin Renvoize 2020-04-16 07:12:09 UTC
Comment on attachment 99898 [details] [review]
Bug 23681: Allow for changes to debarments

Review of attachment 99898 [details] [review]:
-----------------------------------------------------------------

::: koha-tmpl/intranet-tmpl/prog/en/includes/borrower_debarments.inc
@@ -26,5 @@
> -                                    Overdues
> -                                [% CASE 'SUSPENSION' %]
> -                                    Suspension
> -                                [% CASE 'DISCHARGE' %]
> -                                    Discharge

Simply adding

    [% CASE %]
        [% restriction_types.$dtype.display_text | html %]

To the end of this SWITCH block instead of replacing the block entirely should get this passed QA in my opinion.
Comment 74 Martin Renvoize 2021-03-03 15:16:27 UTC
The customer requires being able to change the hard coded values.. as such this bug is blocked until we have translatable authorized values
Comment 75 Katrin Fischer 2022-01-07 14:43:09 UTC
Could we do something like an overwrite option?

We use the default descriptions when the lib/lib_opac are empty and we use the description of those, if they are set?

The other things is me wondering if using authorized value would not only be a temporary solution, making it necessary soon to move debarment types to their own table to be more flexible with configuration. In this case we could have a column for the description too - it would be even a little easier.

And we could then develop the table further to have more columns that make the behavior of a debarment more granular (block renewals, block issuing, block holds, which category types can it be applied to, etc.).
Comment 76 Martin Renvoize 2022-01-07 19:52:13 UTC
(In reply to Katrin Fischer from comment #75)
> Could we do something like an overwrite option?
> 
> We use the default descriptions when the lib/lib_opac are empty and we use
> the description of those, if they are set?
> 

Nope, that would still break translations as Jonathan suggests.  The issue is that you cant define that default for each language.. only a single language.

> The other things is me wondering if using authorized value would not only be
> a temporary solution, making it necessary soon to move debarment types to
> their own table to be more flexible with configuration. In this case we
> could have a column for the description too - it would be even a little
> easier.

This development doesn't use AV's specifically for the reasons you suggest.

> 
> And we could then develop the table further to have more columns that make
> the behavior of a debarment more granular (block renewals, block issuing,
> block holds, which category types can it be applied to, etc.).

I've been waiting years for the AV translations proof work to work their way through.. their holding up a whole plethora of bugs including this one.
Comment 77 Katrin Fischer 2022-01-07 21:03:04 UTC
I thought we could do it similar to account types, just with the addition of allowing to overwrite the standard description. If the overwrite is empty, we use what is in the templates. So we could keep the standard ones translatable.

For the table vs AV - I was didn't read far enough - sorry. 

But... if we are no longer translating an AV... shoudl this not be a little easier in terms of 'hugeness' of development? Maybe it would be easier to start here doing something similar than we have for itemtypes?
Comment 78 Andrew Fuerste-Henry 2022-02-08 21:57:04 UTC
I see this bug is a bit stuck, but commenting to say I like the idea!
Comment 79 Martin Renvoize 2022-02-09 14:37:58 UTC Comment hidden (obsolete)
Comment 80 Martin Renvoize 2022-02-09 14:38:04 UTC Comment hidden (obsolete)
Comment 81 Martin Renvoize 2022-02-09 14:38:09 UTC Comment hidden (obsolete)
Comment 82 Martin Renvoize 2022-02-09 14:38:14 UTC Comment hidden (obsolete)
Comment 83 Martin Renvoize 2022-02-09 14:38:20 UTC Comment hidden (obsolete)
Comment 84 Martin Renvoize 2022-02-09 14:38:24 UTC Comment hidden (obsolete)
Comment 85 Martin Renvoize 2022-02-09 14:38:29 UTC Comment hidden (obsolete)
Comment 86 Martin Renvoize 2022-02-09 14:38:34 UTC Comment hidden (obsolete)
Comment 87 Martin Renvoize 2022-02-09 14:38:39 UTC Comment hidden (obsolete)
Comment 88 Martin Renvoize 2022-02-09 14:38:44 UTC Comment hidden (obsolete)
Comment 89 Martin Renvoize 2022-02-09 14:38:49 UTC Comment hidden (obsolete)
Comment 90 Martin Renvoize 2022-02-09 14:38:54 UTC Comment hidden (obsolete)
Comment 91 Martin Renvoize 2022-02-09 14:40:18 UTC
Rebased and added a follow-up to do as Katrin suggested.. we now use hardcoded translations in the template if the defaults are left unaltered in the existing debarment types.
Comment 92 Katrin Fischer 2022-03-27 12:08:08 UTC
Starting here:

1) QA test tools

Processing files before patches
|========================>| 18 / 18 (100.00%)
Processing files after patches
No schema file found for table debarment_types at /kohadevbox/qa-test-tools/QohA/File/Specific/Kohastructure.pm line 118.
No schema file found for table debarment_types at /kohadevbox/qa-test-tools/QohA/File/Specific/Kohastructure.pm line 118.
|========================>| 18 / 18 (100.00%)

 FAIL	Koha/RestrictionType.pm
   FAIL	  forbidden patterns
		forbidden pattern: Incorrect license statement (using postal address), may be a false positive if the file is coming from outside Koha (bug 24545) (line 16)

 FAIL	Koha/RestrictionTypes.pm
   FAIL	  forbidden patterns
		forbidden pattern: Incorrect license statement (using postal address), may be a false positive if the file is coming from outside Koha (bug 24545) (line 16)

 FAIL	admin/restrictions.pl
   FAIL	  critic
		Subroutine "new" called using indirect syntax at line 27, column 13. See page 349 of PBP.
   FAIL	  forbidden patterns
		forbidden pattern: Script permissions is authnotrequired => 0, it could be correct for an OPAC script if it is was you really want error (bug 24663) (line 38)

 OK	circ/circulation.pl
 OK	installer/data/mysql/kohastructure.sql
 OK	installer/data/mysql/mandatory/sysprefs.sql
 FAIL	koha-tmpl/intranet-tmpl/prog/css/src/staff-global.scss
   FAIL	  css_and_scss_in_sync
		Found CSS file not in sync with its SCSS file, use yarn build. This is not blocker, testers can generate the .css file if they need it, see https://wiki.koha-community.org/wiki/Working_with_SCSS_in_the_OPAC_and_staff_client

 OK	koha-tmpl/intranet-tmpl/prog/en/includes/borrower_debarments.inc
 OK	koha-tmpl/intranet-tmpl/prog/en/includes/permissions.inc
 OK	koha-tmpl/intranet-tmpl/prog/en/modules/admin/admin-home.tt
 FAIL	koha-tmpl/intranet-tmpl/prog/en/modules/admin/restrictions.tt
   FAIL	  forbidden patterns
		forbidden pattern: Title elements must start with the unique information (bug 26703) (line 6)

 OK	koha-tmpl/intranet-tmpl/prog/en/modules/members/memberentrygen.tt
 OK	koha-tmpl/intranet-tmpl/prog/js/restrictiontypes.js
 OK	members/memberentry.pl
 OK	members/mod_debarment.pl
 OK	members/moremember.pl
 FAIL	t/db_dependent/RestrictionType.t
   FAIL	  file permissions
		File must have the exec flag

 FAIL	t/db_dependent/RestrictionTypes.t
   FAIL	  file permissions
		File must have the exec flag

2) Sample data for installer

The sample data added here is .sql not a .yml, but they might contain strings to translate. Can you please verify?
But we still need the .sql files to add to the remaining 'old style' installers.

3) Database structure

ronly and dflt could be improved as column names. ronly = read only, but dlft?
Otherwise as far as I can tell it all seems to match up between new and updated installations.

4) Preference

So the preference is only about the pull down when adding a patron restriction, correct? If you want to make me really happy, please and with a . :) But I believe options need to be changed to 1 and 0?

+         - pref: PatronRestrictionTypes
+           choices:
+               yes: Allow
+               no: Don't allow
+         - "the type of patron restriction to be specified when applying manually"


5) Page title

It needs to be updated to reflect the accessibility work starting with the most specific bits, but I think the QA tool already caught that:

+<title>Koha &rsaquo; Administration &rsaquo; Patron restrictions &rsaquo; [% IF op == 'add_form' %][% IF ( restriction ) %]Modify restriction '[% restriction.display_text | html %]'[% ELSE %]New restriction[% END %][% END %]

6) New permission - OK

I wondered if the new permission should be assigned to someone... but I guess it works ok. If the user has module permission already, they will have permission for the new page. Otherwise it will have to be assigned, but existing functionality keeps working meanwhile. So all good.
Comment 93 Martin Renvoize 2022-03-28 10:32:46 UTC Comment hidden (obsolete)
Comment 94 Martin Renvoize 2022-03-28 10:32:51 UTC Comment hidden (obsolete)
Comment 95 Martin Renvoize 2022-03-28 10:32:55 UTC Comment hidden (obsolete)
Comment 96 Martin Renvoize 2022-03-28 10:33:00 UTC Comment hidden (obsolete)
Comment 97 Martin Renvoize 2022-03-28 10:33:05 UTC Comment hidden (obsolete)
Comment 98 Martin Renvoize 2022-03-28 10:33:09 UTC Comment hidden (obsolete)
Comment 99 Martin Renvoize 2022-03-28 10:33:14 UTC Comment hidden (obsolete)
Comment 100 Martin Renvoize 2022-03-28 10:33:18 UTC Comment hidden (obsolete)
Comment 101 Martin Renvoize 2022-03-28 10:33:23 UTC Comment hidden (obsolete)
Comment 102 Martin Renvoize 2022-03-28 10:33:27 UTC Comment hidden (obsolete)
Comment 103 Martin Renvoize 2022-03-28 10:33:32 UTC Comment hidden (obsolete)
Comment 104 Martin Renvoize 2022-03-28 10:33:37 UTC Comment hidden (obsolete)
Comment 105 Martin Renvoize 2022-03-28 10:33:41 UTC Comment hidden (obsolete)
Comment 106 Martin Renvoize 2022-03-28 10:33:46 UTC Comment hidden (obsolete)
Comment 107 Martin Renvoize 2022-03-28 10:33:51 UTC Comment hidden (obsolete)
Comment 108 Martin Renvoize 2022-03-28 10:35:36 UTC
QA Fixes Done
Comment 109 Martin Renvoize 2022-03-28 10:37:00 UTC
More to do... I missed Katrins extra comments beyond the QA script failure.. oops
Comment 110 Martin Renvoize 2022-03-28 11:42:20 UTC Comment hidden (obsolete)
Comment 111 Martin Renvoize 2022-03-28 11:48:51 UTC Comment hidden (obsolete)
Comment 112 Martin Renvoize 2022-03-28 11:48:56 UTC Comment hidden (obsolete)
Comment 113 Martin Renvoize 2022-03-28 11:51:19 UTC
(In reply to Katrin Fischer from comment #92)
> 2) Sample data for installer
> 
I think this is dealt with by having it in the templates instead

> 
> 3) Database structure
> 
> ronly and dflt could be improved as column names. ronly = read only, but
> dlft?

dflt = default, but this is a reserved word so I updated it to is_system (which other places already use)

> 4) Preference

Done

> 5) Page title

Done

> 6) New permission - OK

I think this is OK.
Comment 114 Katrin Fischer 2022-03-29 06:15:34 UTC
I am sorry, this got rather long again. It might not look like it, but I think we are really close and it WOULD make a great starting point for making the restriction system more granular.

1) Installer data again

(In reply to Martin Renvoize from comment #113)
> (In reply to Katrin Fischer from comment #92)
> > 2) Sample data for installer
> > 
> I think this is dealt with by having it in the templates instead

I had a closer look here and the installer file needs updating one way around or the other:

I we don't want to translate it, it should be in https://git.koha-community.org/Koha-community/Koha/src/branch/master/installer/data/mysql/mandatory.

If we don't have it wrong, we should transform to .yml and also add it to fr-FR, the remaining SQL installer. The .yml file structure looks easy enough in how to mark the translatable bits and how to add a description for the installer:
https://git.koha-community.org/Koha-community/Koha/src/branch/master/installer/data/mysql/en/mandatory

I either case the .txt needs to be removed.

I think the latter would be the nicer solution, as the display text translated would still be nice for reports and such. (I'd also be in favor of moving account_credit_types and debit_types for that reason, but that's another story :) )

+INSERT INTO debarment_types (code, display_text, readonly, system) VALUES
+    ('MANUAL', 'Manual', 1, 1),
+    ('OVERDUES', 'Overdues', 1, 0),
+    ('SUSPENSION', 'Suspension', 1, 0),
+    ('DISCHARGE', 'Discharge', 1, 0);

2) CSS update

I believe Bug 23681: CSS Build should be dropped. It's expected that you generate the CSS files locally. It might create conflicts, but I can just drop/skip it then.

3) Typo in database update / column names

a)
+                system tinyint(1) NOT NULL DEFAULT 0

Should be: is_system. I've fixed it locally for testing further:
alter table debarment_types rename column system to is_system;

b) I have been thinking more about the different columns and I think there is an error there:

+------------+--------------+----------+-----------+
| code       | display_text | readonly | is_system |
+------------+--------------+----------+-----------+
| DISCHARGE  | Discharge    |        1 |         0 |
| MANUAL     | Manual       |        1 |         1 |
| OVERDUES   | Overdues     |        1 |         0 |
| SUSPENSION | Suspension   |        1 |         0 |
+------------+--------------+----------+-----------+

read_only should be is_system = It's internal, don't change it. Applies to all currently added ones.

is_system, was dflt = default = means it's used when the pref is turned off. So it should be default actually.

AND: I think we need another column:

can_be_added_manually (see account_credit_types for comparison)

Because right now the list of restrictions on the patron account will show ALL restrictions defined in debarment_types and I feel like we are asking for trouble if we allow to set restrictions manually that are supposed to be added automatically. Like a DISCHARGE restriction should be linked to an entry in the discharges table somehow, an OVERDUES restriction can be lifted automatically if all overdues are returned, SUSPENSION is calculated on late returns... I'd feel we might want to leave them out of the pulldown really to keep internal behaviors untouched.


4) System preference (sorry, only saw this in the GUI)

Currently the pref appears under "Patrons > Patron relationships", but this is the section for guarantor and family account stuff. I suggest moving it into the "Accounting > Features" tab, that maybe didn't exist yet when this was first written.

5) Page title

There is a > left at the beginning that should not be there if you look at the tab in the browser.

6) Deleting a restriction

When I try to delete a newly created restriction, I see:
Can't locate object method "_new_from_dbic" via package "Koha::DebarmentType" (perhaps you forgot to load "Koha::DebarmentType"?) at /kohadevbox/koha/Koha/Object.pm line 237

7) Tests are failing :(

prove t/db_dependent/RestrictionType.t t/db_dependent/RestrictionTypes.t
t/db_dependent/RestrictionType.t ... 1/3 
#   Failed test 'keyed_on_code returns correctly'
#   at t/db_dependent/RestrictionType.t line 58.
#     Structures begin differing at:
#          $got->{MANUAL} = HASH(0x5618db704c68)
#     $expected->{MANUAL} = Does not exist
# Looks like you failed 1 test of 3.
t/db_dependent/RestrictionType.t ... Dubious, test returned 1 (wstat 256, 0x100)
Failed 1/3 subtests 
t/db_dependent/RestrictionTypes.t .. 1/6 DBIx::Class::Storage::DBI::select_single(): Query returned more than one row.  SQL that returns multiple rows is DEPRECATED for ->find and ->single at /kohadevbox/koha/Koha/Objects.pm line 96
Can't locate object method "_new_from_dbic" via package "Koha::DebarmentType" (perhaps you forgot to load "Koha::DebarmentType"?) at /kohadevbox/koha/Koha/Object.pm line 237.
# Looks like your test exited with 11 just after 3.
t/db_dependent/RestrictionTypes.t .. Dubious, test returned 11 (wstat 2816, 0xb00)
Failed 3/6 subtests 

Test Summary Report
-------------------
t/db_dependent/RestrictionType.t (Wstat: 256 Tests: 3 Failed: 1)
  Failed test:  3
  Non-zero exit status: 1
t/db_dependent/RestrictionTypes.t (Wstat: 2816 Tests: 3 Failed: 0)
  Non-zer
Comment 115 Emmi Takkinen 2022-05-03 11:24:51 UTC Comment hidden (obsolete)
Comment 116 Emmi Takkinen 2022-05-03 11:25:21 UTC Comment hidden (obsolete)
Comment 117 Emmi Takkinen 2022-05-03 11:25:54 UTC Comment hidden (obsolete)
Comment 118 Emmi Takkinen 2022-05-03 11:26:21 UTC Comment hidden (obsolete)
Comment 119 Emmi Takkinen 2022-05-03 11:26:47 UTC Comment hidden (obsolete)
Comment 120 Emmi Takkinen 2022-05-03 11:27:13 UTC Comment hidden (obsolete)
Comment 121 Emmi Takkinen 2022-05-03 11:27:43 UTC Comment hidden (obsolete)
Comment 122 Emmi Takkinen 2022-05-03 11:28:10 UTC Comment hidden (obsolete)
Comment 123 Emmi Takkinen 2022-05-03 11:28:34 UTC Comment hidden (obsolete)
Comment 124 Emmi Takkinen 2022-05-03 11:29:04 UTC Comment hidden (obsolete)
Comment 125 Emmi Takkinen 2022-05-03 11:29:34 UTC Comment hidden (obsolete)
Comment 126 Emmi Takkinen 2022-05-03 11:30:03 UTC Comment hidden (obsolete)
Comment 127 Emmi Takkinen 2022-05-03 11:30:31 UTC Comment hidden (obsolete)
Comment 128 Emmi Takkinen 2022-05-03 11:31:02 UTC Comment hidden (obsolete)
Comment 129 Emmi Takkinen 2022-05-03 11:31:31 UTC Comment hidden (obsolete)
Comment 130 Emmi Takkinen 2022-05-03 11:32:01 UTC Comment hidden (obsolete)
Comment 131 Emmi Takkinen 2022-05-03 11:32:35 UTC Comment hidden (obsolete)
Comment 132 Emmi Takkinen 2022-05-03 11:32:58 UTC Comment hidden (obsolete)
Comment 133 Emmi Takkinen 2022-05-03 11:38:00 UTC
Rebased patches and added couple new ones where I hopefully catched up all QA issues from comment 114. Also I dropped and obsoleted CSS patch since it broke the UI in several pages and as Katrin stated:

>It's expected that you generate the CSS files locally.
Comment 134 Martin Renvoize 2022-05-03 13:34:42 UTC
Thanks for jumping on this rebase and clean up Emmi, teamwork for the win!
Comment 135 Martin Renvoize 2022-05-03 13:50:02 UTC
Testing follow-ups now..
Comment 136 Martin Renvoize 2022-05-03 13:55:49 UTC
We're back to failing here.. whilst I understand the want to translate the system options, this follow-up breaks the ability to customise those same options for display... which was a core requirement for the original Sponsor.

I'm torn.. I feel you should be able to customise those if you really want to.

I also think that the 'Manual' option should be listed as one you can add manually ;)
Comment 137 Martin Renvoize 2022-05-03 13:57:35 UTC
I also disagree with the syspref move.. this isn't an accounting feature.. it has nothing to do with money.
Comment 138 Martin Renvoize 2022-05-03 14:01:19 UTC
I think the pref should live under circulation or patron tabs somewhere.. we already have some Debartment/Restriction preferences it could perhaps go with.

AutoRemoveOverduesRestrictions, RestrictionBlockRenewing, CumulativeRestrictionPeriods all appear under circulation.. so I reckon that's where if fits.
Comment 139 Martin Renvoize 2022-05-03 14:02:51 UTC
I can happily move the pref.. but the translation vs customisation is a wider issue.. it needs some cleaning up either way, but I need input.
Comment 140 Martin Renvoize 2022-05-03 14:14:38 UTC
See coment 75, 76, 77 and 91 for details about the way translations were handled here.. it was a very deliberate choice to leave them as translations in the Templates and not move them to the Database.. but moving them to the database here we loose the ability to define custom display texts locally.
Comment 141 Martin Renvoize 2022-05-03 15:45:14 UTC
Working on follow-ups
Comment 142 Emmi Takkinen 2022-05-04 06:54:07 UTC
(In reply to Martin Renvoize from comment #137)
> I also disagree with the syspref move.. this isn't an accounting feature..
> it has nothing to do with money.

Oof, I misunderstood "Accounting" part here. Accounting => account => everything that has something to do with handling patrons account :') But I agree, the syspref should probably be put either under Patron->General or maybe Circulation->Checkout, since most of the other similar sysprefs are there (personally I think we could have section for restrictions or even general section for patron account handling but that's a whole different thing).

As for not being able to modify default restrictions, that's a mistake in code. This line 
> $restriction->display_text($display_text);  
should be above unless statement. After moving it system restrictions can at least be modified from UI.
Comment 143 Emmi Takkinen 2022-05-04 07:07:54 UTC
And I forgot to add to my first comment, I didn't include fr-FR translated files in these patches as Katrin suggested, since I'm not a native speaker/don't even speak french :D So they are still missing from here.
Comment 144 Martin Renvoize 2022-05-04 07:21:03 UTC
Hi Emmi, 

I do really appreciate your work here, hope I didn't come across mean in my comments.. it turned out a little more verbose than intended as I worked out how it all fits together again.

Do you happen to still have a branch around for this?  I've got a couple of follow-up patches to add but I've discovered that when trying to apply the patches from here I get some weird unexpected conflicts and the result is that we somehow drop a patch when applying at the moment.

If you still have the branch, I could use that as a base to try and work on the fixes.
Comment 145 Emmi Takkinen 2022-05-04 08:05:17 UTC
(In reply to Martin Renvoize from comment #144)
> Hi Emmi, 
> 
> I do really appreciate your work here, hope I didn't come across mean in my
> comments.. it turned out a little more verbose than intended as I worked out
> how it all fits together again.
> 
You didn't sound mean at all, so don't worry :o And I understand perfectly that these thinks tend to turn out more complex than they first look :D 

> Do you happen to still have a branch around for this?  I've got a couple of
> follow-up patches to add but I've discovered that when trying to apply the
> patches from here I get some weird unexpected conflicts and the result is
> that we somehow drop a patch when applying at the moment.
> 
> If you still have the branch, I could use that as a base to try and work on
> the fixes.

I do, here: https://github.com/emta001/Koha/tree/bug-23681 Can you get it from there?
Comment 146 Martin Renvoize 2022-05-04 09:28:44 UTC
Awesome, that worked perfectly.. no idea why the patches on BZ apply weirdly.

Right.. I'll add my follow-ups shortly.. may squash a few patches too, but keep enough that we get all the attributions after so many people have worked on this.
Comment 147 Martin Renvoize 2022-05-04 11:41:49 UTC Comment hidden (obsolete)
Comment 148 Martin Renvoize 2022-05-04 11:41:55 UTC Comment hidden (obsolete)
Comment 149 Martin Renvoize 2022-05-04 11:42:01 UTC Comment hidden (obsolete)
Comment 150 Martin Renvoize 2022-05-04 11:42:09 UTC Comment hidden (obsolete)
Comment 151 Martin Renvoize 2022-05-04 11:42:16 UTC Comment hidden (obsolete)
Comment 152 Martin Renvoize 2022-05-04 11:42:22 UTC Comment hidden (obsolete)
Comment 153 Martin Renvoize 2022-05-04 11:42:29 UTC Comment hidden (obsolete)
Comment 154 Martin Renvoize 2022-05-04 11:42:35 UTC Comment hidden (obsolete)
Comment 155 Martin Renvoize 2022-05-04 11:42:42 UTC Comment hidden (obsolete)
Comment 156 Martin Renvoize 2022-05-04 11:42:49 UTC Comment hidden (obsolete)
Comment 157 Martin Renvoize 2022-05-04 11:42:56 UTC Comment hidden (obsolete)
Comment 158 Martin Renvoize 2022-05-04 11:43:02 UTC Comment hidden (obsolete)
Comment 159 Martin Renvoize 2022-05-04 11:43:09 UTC Comment hidden (obsolete)
Comment 160 Martin Renvoize 2022-05-04 11:43:16 UTC Comment hidden (obsolete)
Comment 161 Martin Renvoize 2022-05-04 11:43:23 UTC Comment hidden (obsolete)
Comment 162 Martin Renvoize 2022-05-04 11:43:29 UTC Comment hidden (obsolete)
Comment 163 Martin Renvoize 2022-05-04 11:43:36 UTC Comment hidden (obsolete)
Comment 164 Martin Renvoize 2022-05-04 11:43:43 UTC Comment hidden (obsolete)
Comment 165 Martin Renvoize 2022-05-04 11:43:49 UTC Comment hidden (obsolete)
Comment 166 Martin Renvoize 2022-05-04 11:43:57 UTC Comment hidden (obsolete)
Comment 167 Martin Renvoize 2022-05-04 11:44:04 UTC Comment hidden (obsolete)
Comment 168 Martin Renvoize 2022-05-04 11:44:11 UTC Comment hidden (obsolete)
Comment 169 Martin Renvoize 2022-05-04 11:44:17 UTC Comment hidden (obsolete)
Comment 170 Martin Renvoize 2022-05-04 11:47:49 UTC
That was "fun"..

The patchset now all applies cleanly again and I believe the default handling now works as requested along with only displaying non system types as manually addable.

The translation options are also fixed.

Back to the QA queue
Comment 171 Katrin Fischer 2022-05-06 06:49:16 UTC
There is one fail in the QA test tools here:

 FAIL	installer/data/mysql/kohastructure.sql
   FAIL	  tinyint_has_boolean_flag
		The new column debarment_types.is_system is using TINYINT(1) as type but is not defined as boolean in the schema file (Koha/Schema/Result/DebarmentType.pm), see the SQL12 coding guideline
		The new column debarment_types.is_default is using TINYINT(1) as type but is not defined as boolean in the schema file (Koha/Schema/Result/DebarmentType.pm), see the SQL12 coding guideline
Comment 172 Katrin Fischer 2022-05-06 06:52:03 UTC
Also tests are failing:

prove t/db_dependent/RestrictionType.t t/db_dependent/RestrictionTypes.t
t/db_dependent/RestrictionType.t ... 1/3 DBIx::Class::Storage::DBI::_dbh_execute(): DBI Exception: DBD::mysql::st execute failed: Unknown column 'me.default_value' in 'where clause' at /kohadevbox/koha/Koha/Objects.pm line 96
# Looks like your test exited with 11 just after 2.
t/db_dependent/RestrictionType.t ... Dubious, test returned 11 (wstat 2816, 0xb00)
Failed 1/3 subtests 
t/db_dependent/RestrictionTypes.t .. 1/6 DBIx::Class::Storage::DBI::_dbh_execute(): DBI Exception: DBD::mysql::st execute failed: Unknown column 'me.default_value' in 'where clause' at /kohadevbox/koha/Koha/Objects.pm line 96
# Looks like your test exited with 11 just after 3.
t/db_dependent/RestrictionTypes.t .. Dubious, test returned 11 (wstat 2816, 0xb00)
Failed 3/6 subtests 

Test Summary Report
-------------------
t/db_dependent/RestrictionType.t (Wstat: 2816 Tests: 2 Failed: 0)
  Non-zero exit status: 11
  Parse errors: Bad plan.  You planned 3 tests but ran 2.
t/db_dependent/RestrictionTypes.t (Wstat: 2816 Tests: 3 Failed: 0)
  Non-zero exit status: 11
  Parse errors: Bad plan.  You planned 6 tests but ran 3.
Files=2, Tests=5,  2 wallclock secs ( 0.01 usr  0.01 sys +  1.88 cusr  0.15 csys =  2.05 CPU)
Result: FAIL


I made sure to apply the database update before running the tests.

Can you please check?
Comment 173 Martin Renvoize 2022-05-06 08:40:17 UTC Comment hidden (obsolete)
Comment 174 Martin Renvoize 2022-05-06 08:40:24 UTC Comment hidden (obsolete)
Comment 175 Martin Renvoize 2022-05-06 08:40:30 UTC Comment hidden (obsolete)
Comment 176 Martin Renvoize 2022-05-06 08:40:36 UTC Comment hidden (obsolete)
Comment 177 Martin Renvoize 2022-05-06 08:40:43 UTC Comment hidden (obsolete)
Comment 178 Martin Renvoize 2022-05-06 08:40:48 UTC Comment hidden (obsolete)
Comment 179 Martin Renvoize 2022-05-06 08:40:55 UTC Comment hidden (obsolete)
Comment 180 Martin Renvoize 2022-05-06 08:41:01 UTC Comment hidden (obsolete)
Comment 181 Martin Renvoize 2022-05-06 08:41:07 UTC Comment hidden (obsolete)
Comment 182 Martin Renvoize 2022-05-06 08:41:14 UTC Comment hidden (obsolete)
Comment 183 Martin Renvoize 2022-05-06 08:41:21 UTC Comment hidden (obsolete)
Comment 184 Martin Renvoize 2022-05-06 08:41:28 UTC Comment hidden (obsolete)
Comment 185 Martin Renvoize 2022-05-06 08:41:35 UTC Comment hidden (obsolete)
Comment 186 Martin Renvoize 2022-05-06 08:41:42 UTC Comment hidden (obsolete)
Comment 187 Martin Renvoize 2022-05-06 08:41:48 UTC Comment hidden (obsolete)
Comment 188 Martin Renvoize 2022-05-06 08:41:54 UTC Comment hidden (obsolete)
Comment 189 Martin Renvoize 2022-05-06 08:42:01 UTC Comment hidden (obsolete)
Comment 190 Martin Renvoize 2022-05-06 08:42:07 UTC Comment hidden (obsolete)
Comment 191 Martin Renvoize 2022-05-06 08:42:13 UTC Comment hidden (obsolete)
Comment 192 Martin Renvoize 2022-05-06 08:42:20 UTC Comment hidden (obsolete)
Comment 193 Martin Renvoize 2022-05-06 08:42:26 UTC Comment hidden (obsolete)
Comment 194 Martin Renvoize 2022-05-06 08:42:33 UTC Comment hidden (obsolete)
Comment 195 Martin Renvoize 2022-05-06 08:42:39 UTC Comment hidden (obsolete)
Comment 196 Martin Renvoize 2022-05-06 08:42:45 UTC Comment hidden (obsolete)
Comment 197 Martin Renvoize 2022-05-06 08:44:06 UTC
One more little follow-up for the booleans issue and a rebase to fix the other problems.

Hopefully it should all be passing now Katrin :)
Comment 198 Katrin Fischer 2022-06-29 14:27:18 UTC
Could you please rebase?
Comment 199 Martin Renvoize 2022-06-29 15:10:37 UTC Comment hidden (obsolete)
Comment 200 Martin Renvoize 2022-06-29 15:10:44 UTC Comment hidden (obsolete)
Comment 201 Martin Renvoize 2022-06-29 15:10:51 UTC Comment hidden (obsolete)
Comment 202 Martin Renvoize 2022-06-29 15:10:57 UTC Comment hidden (obsolete)
Comment 203 Martin Renvoize 2022-06-29 15:11:04 UTC Comment hidden (obsolete)
Comment 204 Martin Renvoize 2022-06-29 15:11:11 UTC Comment hidden (obsolete)
Comment 205 Martin Renvoize 2022-06-29 15:11:18 UTC Comment hidden (obsolete)
Comment 206 Martin Renvoize 2022-06-29 15:11:25 UTC Comment hidden (obsolete)
Comment 207 Martin Renvoize 2022-06-29 15:11:31 UTC Comment hidden (obsolete)
Comment 208 Martin Renvoize 2022-06-29 15:11:38 UTC Comment hidden (obsolete)
Comment 209 Martin Renvoize 2022-06-29 15:11:45 UTC Comment hidden (obsolete)
Comment 210 Martin Renvoize 2022-06-29 15:11:52 UTC Comment hidden (obsolete)
Comment 211 Martin Renvoize 2022-06-29 15:11:58 UTC Comment hidden (obsolete)
Comment 212 Martin Renvoize 2022-06-29 15:12:05 UTC Comment hidden (obsolete)
Comment 213 Martin Renvoize 2022-06-29 15:12:12 UTC Comment hidden (obsolete)
Comment 214 Martin Renvoize 2022-06-29 15:12:18 UTC Comment hidden (obsolete)
Comment 215 Martin Renvoize 2022-06-29 15:12:25 UTC Comment hidden (obsolete)
Comment 216 Martin Renvoize 2022-06-29 15:12:31 UTC Comment hidden (obsolete)
Comment 217 Martin Renvoize 2022-06-29 15:12:38 UTC Comment hidden (obsolete)
Comment 218 Martin Renvoize 2022-06-29 15:12:46 UTC Comment hidden (obsolete)
Comment 219 Martin Renvoize 2022-06-29 15:12:52 UTC Comment hidden (obsolete)
Comment 220 Martin Renvoize 2022-06-29 15:12:59 UTC Comment hidden (obsolete)
Comment 221 Martin Renvoize 2022-06-29 15:13:05 UTC Comment hidden (obsolete)
Comment 222 Martin Renvoize 2022-06-29 15:13:13 UTC Comment hidden (obsolete)
Comment 223 Martin Renvoize 2022-06-29 15:18:58 UTC
Rebased